﻿<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
<xsl:output method="xml" indent="yes" version="1.0" encoding="UTF-8" /> 
  <xsl:template match="/*[1]">
    <ows>
      <xsl:attribute name="id"></xsl:attribute>
      <xsl:apply-templates select="*:ServiceIdentification"/>
      <xsl:apply-templates select="*:OperationsMetadata"/>
    </ows>
  </xsl:template>
  
  <xsl:template match="*:ServiceIdentification">
    <url></url>
    <service>
      <xsl:value-of select="*:ServiceType"/>
    </service>
    <version>
      <xsl:value-of select="*:ServiceTypeVersion"/>
    </version>
  </xsl:template>
  
  <xsl:template match="*:OperationsMetadata">
    <xsl:for-each select="*:Operation">
     <request>
        <xsl:attribute name="id">
          <xsl:value-of select="@*:name"/>
        </xsl:attribute>
        <xsl:for-each select="*:Parameter">
          <parameter>
            <xsl:attribute name="id">
              <xsl:value-of select="@*:name"/>
            </xsl:attribute>
            <xsl:for-each select="*:Value">
              <value>
                <xsl:value-of select="self::*:Value"/>
              </value>
            </xsl:for-each>
          </parameter>
        </xsl:for-each>
      </request>
    </xsl:for-each>
    <request id="Transaction">
      <parameter id="inputFormat">
        <value>text/xml; subtype=gml/3.1.1</value>
      </parameter>
      <parameter id="idgen">
        <value>GenerateNew</value>
      </parameter>
    </request>
  </xsl:template>
  
</xsl:stylesheet>
