﻿<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
  <xsl:output method="xml" indent="yes" version="1.0" encoding="UTF-8"/>
  
  <xsl:template match="/*[1]">
    <ows>
      <xsl:attribute name="id">newWCS1.0.0</xsl:attribute>
      <service>WCS</service>
      <version>1.0.0</version>
      <xsl:apply-templates select="*:Capability"/>
    </ows>
  </xsl:template>
  
  <xsl:template match="*:Capability">
    <xsl:if test="exists(*:Request)">
      <xsl:apply-templates select="//*:GetCoverage"/>
      <xsl:apply-templates select="//*:DescribeCoverage"/>
      <xsl:apply-templates select="//*:GetCapabilities"/>
    </xsl:if>
    <request id="SendSavedQuery" selected="true">
      <parameter id="file">
        <value>./queryTest.xml</value>
      </parameter>
    </request>
  </xsl:template>
  
  <xsl:template name="coverageName">
    <xsl:if test="exists(//*:CoverageOfferingBrief)">
      <xsl:for-each select="//*:CoverageOfferingBrief">
        <xsl:value-of select="*:name"/>
      </xsl:for-each>
    </xsl:if>
  </xsl:template>
  
  <xsl:template match="*:GetCoverage">
    <request>
      <xsl:attribute name="id">GetCoverage</xsl:attribute>
      <parameter id="COVERAGE" selected="true">
        <value>
          <xsl:call-template name="coverageName"/>
        </value>
      </parameter>
      <parameter id="CRS" selected="true">
        <value>EPSG:31466</value>
      </parameter>
      <parameter id="FORMAT" selected="true">
        <value>GeoTiff</value>
      </parameter>
      <parameter id="BBOX" selected="true">
        <value>2558000,5652000,2568000,5662000</value>
      </parameter>
      <parameter id="WIDTH" selected="true">
        <value>1000</value>
      </parameter>
      <parameter id="HEIGHT" selected="true">
        <value>1000</value>
      </parameter>
  <!--    <parameter id="TIME">
        <value/>
      </parameter> -->
      <parameter id="RESX">
        <value>10</value>
      </parameter>
      <parameter id="RESY">
        <value>10</value>
      </parameter><!--
      <parameter id="RESPONSE_CRS">
        <value>EPSG:31466</value>
      </parameter>
      <parameter id="EXCEPTIONS">
        <value>application/vnd.ogc.se_xml</value>
      </parameter>-->
    </request>
  </xsl:template>
  
  <xsl:template match="*:DescribeCoverage">
    <request>
      <xsl:attribute name="id">DescribeCoverage</xsl:attribute>
      <parameter id="COVERAGE">
        <value/>
      </parameter>
    </request>
  </xsl:template>
  
  <xsl:template match="*:GetCapabilities">
    <request>
      <xsl:attribute name="id">GetCapabilities</xsl:attribute>
<!--      <parameter id="SERVICE" selected="true">
        <value>WCS</value>
      </parameter>-->
      <parameter id="VERSION">
        <value>1.0.0</value>
      </parameter>
      <parameter id="SECTION">
        <value>/</value>
      </parameter>
      <parameter id="UPDATESEQUENCE">
        <value/>
      </parameter>
    </request>
  </xsl:template>
</xsl:stylesheet>
